From 7fd8280b72bc0f252c7a0718f241bddbef65ec68 Mon Sep 17 00:00:00 2001
From: Robert Haas <rhaas@postgresql.org>
Date: Mon, 24 Feb 2025 10:57:11 -0500
Subject: [PATCH] EXPLAIN: Always use two fractional digits for row counts.

Commit ddb17e387aa28d61521227377b00f997756b8a27 attempted to avoid
confusing users by displaying digits after the decimal point only when
nloops > 1, since it's impossible to have a fraction row count after a
single iteration. However, this made the regression tests unstable since
parallal queries will have nloops>1 for all nodes below the Gather or
Gather Merge in normal cases, but if the workers don't start in time and
the leader finishes all the work, they will suddenly have nloops==1,
making it unpredictable whether the digits after the decimal point would
be displayed or not.

Various fixes are possible here. For example, it has previously been
proposed that we should try to display the digits after the decimal
point only if rows/nloops is an integer, but rows is a float so it's not
theoretically an exact quantity -- precision could be lost in extreme
cases. It has also been proposed that we should try to display the
digits after the decimal point only if we're under some sort of
construct that could potentially cause looping regardless of whether it
actually does. While such ideas are not without merit, this patch adopts
the much simpler solution of always display two decimal digits. If that
approach stands up to scrutiny from the buildfarm and human users, it
spares us the trouble of doing anything more complex; if not, we can
reassess.

This commit incidentally reverts 44cbba9a7f51a3888d5087fc94b23614ba2b81f2,
which should no longer be needed.
---
 .../expected/level_tracking.out               |  24 +-
 .../postgres_fdw/expected/postgres_fdw.out    |  60 +--
 src/backend/commands/explain.c                |  34 +-
 src/test/regress/expected/brin_multi.out      |  72 +--
 src/test/regress/expected/explain.out         |  89 ++--
 src/test/regress/expected/gin.out             |  20 +-
 .../regress/expected/incremental_sort.out     |  20 +-
 src/test/regress/expected/matview.out         |   8 +-
 src/test/regress/expected/memoize.out         |  94 ++--
 src/test/regress/expected/merge.out           | 124 ++---
 src/test/regress/expected/misc_functions.out  |  60 +--
 src/test/regress/expected/partition_prune.out | 480 +++++++++---------
 src/test/regress/expected/select.out          |   6 +-
 src/test/regress/expected/select_into.out     |  16 +-
 src/test/regress/expected/select_parallel.out |  12 +-
 src/test/regress/expected/subselect.out       |  12 +-
 src/test/regress/expected/tidscan.out         |  16 +-
 src/test/regress/sql/explain.sql              |   3 -
 18 files changed, 562 insertions(+), 588 deletions(-)

diff --git a/src/backend/commands/explain.c b/src/backend/commands/explain.c
index c0d614866a9..4271dd48e4e 100644
--- a/src/backend/commands/explain.c
+++ b/src/backend/commands/explain.c
@@ -1998,10 +1998,7 @@ ExplainNode(PlanState *planstate, List *ancestors,
 			if (es->timing)
 				appendStringInfo(es->str, "time=%.3f..%.3f ", startup_ms, total_ms);
 
-			if (nloops > 1)
-				appendStringInfo(es->str, "rows=%.2f loops=%.0f)", rows, nloops);
-			else
-				appendStringInfo(es->str, "rows=%.0f loops=%.0f)", rows, nloops);
+			appendStringInfo(es->str, "rows=%.2f loops=%.0f)", rows, nloops);
 		}
 		else
 		{
@@ -2012,16 +2009,8 @@ ExplainNode(PlanState *planstate, List *ancestors,
 				ExplainPropertyFloat("Actual Total Time", "ms", total_ms,
 									 3, es);
 			}
-			if (nloops > 1)
-			{
-				ExplainPropertyFloat("Actual Rows", NULL, rows, 2, es);
-				ExplainPropertyFloat("Actual Loops", NULL, nloops, 0, es);
-			}
-			else
-			{
-				ExplainPropertyFloat("Actual Rows", NULL, rows, 0, es);
-				ExplainPropertyFloat("Actual Loops", NULL, nloops, 0, es);
-			}
+			ExplainPropertyFloat("Actual Rows", NULL, rows, 2, es);
+			ExplainPropertyFloat("Actual Loops", NULL, nloops, 0, es);
 		}
 	}
 	else if (es->analyze)
@@ -2077,10 +2066,7 @@ ExplainNode(PlanState *planstate, List *ancestors,
 				if (es->timing)
 					appendStringInfo(es->str, "time=%.3f..%.3f", startup_ms, total_ms);
 
-				if (nloops > 1)
-					appendStringInfo(es->str, "rows=%.2f loops=%.0f\n", rows, nloops);
-				else
-					appendStringInfo(es->str, "rows=%.0f loops=%.0f\n", rows, nloops);
+				appendStringInfo(es->str, "rows=%.2f loops=%.0f\n", rows, nloops);
 			}
 			else
 			{
@@ -2092,16 +2078,8 @@ ExplainNode(PlanState *planstate, List *ancestors,
 										 total_ms, 3, es);
 				}
 
-				if (nloops > 1)
-				{
-					ExplainPropertyFloat("Actual Rows", NULL, rows, 2, es);
-					ExplainPropertyFloat("Actual Loops", NULL, nloops, 0, es);
-				}
-				else
-				{
-					ExplainPropertyFloat("Actual Rows", NULL, rows, 0, es);
-					ExplainPropertyFloat("Actual Loops", NULL, nloops, 0, es);
-				}
+				ExplainPropertyFloat("Actual Rows", NULL, rows, 2, es);
+				ExplainPropertyFloat("Actual Loops", NULL, nloops, 0, es);
 			}
 
 			ExplainCloseWorker(n, es);
diff --git a/src/test/regress/sql/explain.sql b/src/test/regress/sql/explain.sql
index c719cca6583..0bafa870496 100644
--- a/src/test/regress/sql/explain.sql
+++ b/src/test/regress/sql/explain.sql
@@ -147,9 +147,6 @@ select jsonb_pretty(
   -- Also remove its sort-type fields, as those aren't 100% stable
   #- '{0,Plan,Plans,0,Sort Method}'
   #- '{0,Plan,Plans,0,Sort Space Type}'
-  -- Actual Rows can be 0 or 0.0 depending on whether loops>1
-  #- '{0,Plan,Plans,0,Actual Rows}'
-  #- '{0,Plan,Plans,0,Plans,0,Actual Rows}'
 );
 
 rollback;
-- 
2.39.3 (Apple Git-145)

